package br.ufes.nemo.seon.ontoloyasservice.generator.service;

import br.ufes.nemo.seon.ontoloyasservice.oaas.Entity;
import com.google.common.collect.Iterables;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class ServiceFilesGenerator extends AbstractGenerator {
  private String PATHSERVICE = "service/src/";
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    fsa.generateFile((this.PATHSERVICE + "pyproject.toml"), this.createPyproject());
    fsa.generateFile((this.PATHSERVICE + "README.md"), this.createReadme());
    fsa.generateFile((this.PATHSERVICE + "requirementes.txt"), this.createRequirements());
    fsa.generateFile((this.PATHSERVICE + "run.sh"), this.createRun());
    fsa.generateFile((this.PATHSERVICE + "VERSION.txt"), this.createVersion());
    fsa.generateFile((this.PATHSERVICE + ".gitignore"), this.gitignore());
    fsa.generateFile((this.PATHSERVICE + "server.py"), this.createServer(IterableExtensions.<Entity>toList(Iterables.<Entity>filter(IteratorExtensions.<EObject>toIterable(resource.getAllContents()), Entity.class))));
  }
  
  private CharSequence createServer(final List<Entity> entities) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("from pprint import pprint");
    _builder.newLine();
    {
      for(final Entity e : entities) {
        _builder.append("from server.");
        String _lowerCase = e.getName().toLowerCase();
        _builder.append(_lowerCase);
        _builder.append("_server import ");
        String _firstUpper = StringExtensions.toFirstUpper(e.getName());
        _builder.append(_firstUpper);
        _builder.append("Server");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("def main():");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("pprint(\"EO: Begin\")");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    {
      for(final Entity e_1 : entities) {
        String _lowerCase_1 = e_1.getName().toLowerCase();
        _builder.append(_lowerCase_1);
        _builder.append("_server = ");
        String _firstUpper_1 = StringExtensions.toFirstUpper(e_1.getName());
        _builder.append(_firstUpper_1);
        _builder.append("Server()");
        _builder.newLineIfNotEmpty();
        String _lowerCase_2 = e_1.getName().toLowerCase();
        _builder.append(_lowerCase_2);
        _builder.append("_server.start()");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.newLine();
    _builder.append("\t");
    _builder.append("pprint(\"EO: End\")");
    _builder.newLine();
    _builder.newLine();
    _builder.append("if __name__ == \"__main__\":");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("main()");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence createPyproject() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("[tool.commitizen]");
    _builder.newLine();
    _builder.append("name = \"cz_conventional_commits\"");
    _builder.newLine();
    _builder.append("version = \"0.0.0\"");
    _builder.newLine();
    _builder.append("tag_format = \"v$version\"");
    _builder.newLine();
    _builder.append("bump_message = \"release $current_version → $new_version\"");
    _builder.newLine();
    _builder.append("version_files = [");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("\"pyproject.toml:version\",");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("\"VERSION.txt\"");
    _builder.newLine();
    _builder.append("]");
    _builder.newLine();
    _builder.newLine();
    _builder.append("style = [");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"qmark\", \"fg:#ff9d00 bold\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"question\", \"bold\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"answer\", \"fg:#ff9d00 bold\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"pointer\", \"fg:#ff9d00 bold\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"highlighted\", \"fg:#ff9d00 bold\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"selected\", \"fg:#cc5454\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"separator\", \"fg:#cc5454\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"instruction\", \"\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"text\", \"\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"disabled\", \"fg:#858585 italic\"]");
    _builder.newLine();
    _builder.append("]");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence createReadme() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("#readme");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence createRequirements() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("colorama==0.4.3");
    _builder.newLine();
    _builder.append("commitizen==1.23.0");
    _builder.newLine();
    _builder.append("decli==0.5.1");
    _builder.newLine();
    _builder.append("xxxxxxxx");
    _builder.newLine();
    _builder.append("factory-boy==2.12.0");
    _builder.newLine();
    _builder.append("Faker==4.1.1");
    _builder.newLine();
    _builder.append("Jinja2==2.11.2");
    _builder.newLine();
    _builder.append("MarkupSafe==1.1.1");
    _builder.newLine();
    _builder.append("packaging==20.4");
    _builder.newLine();
    _builder.append("pika==1.1.0");
    _builder.newLine();
    _builder.append("prompt-toolkit==3.0.5");
    _builder.newLine();
    _builder.append("psycopg2==2.8.5");
    _builder.newLine();
    _builder.append("pyparsing==2.4.7");
    _builder.newLine();
    _builder.append("python-dateutil==2.8.1");
    _builder.newLine();
    _builder.append("questionary==1.5.2");
    _builder.newLine();
    _builder.append("rabbitmqX==1.10.18");
    _builder.newLine();
    _builder.append("six==1.15.0");
    _builder.newLine();
    _builder.append("SQLAlchemy==1.3.18");
    _builder.newLine();
    _builder.append("SQLAlchemy-serializer==1.3.4.2");
    _builder.newLine();
    _builder.append("SQLAlchemy-Utils==0.36.8");
    _builder.newLine();
    _builder.append("termcolor==1.1.0");
    _builder.newLine();
    _builder.append("text-unidecode==1.3");
    _builder.newLine();
    _builder.append("tomlkit==0.5.11");
    _builder.newLine();
    _builder.append("wcwidth==0.2.5");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence createRun() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("python server.py");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence createVersion() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("\"v0.0.0\"");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence gitignore() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("# Byte-compiled / optimized / DLL files");
    _builder.newLine();
    _builder.append("__pycache__/");
    _builder.newLine();
    _builder.append("*.py[cod]");
    _builder.newLine();
    _builder.append("*$py.class");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# C extensions");
    _builder.newLine();
    _builder.append("*.so");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Distribution / packaging");
    _builder.newLine();
    _builder.append(".Python");
    _builder.newLine();
    _builder.append("build/");
    _builder.newLine();
    _builder.append("develop-eggs/");
    _builder.newLine();
    _builder.append("dist/");
    _builder.newLine();
    _builder.append("downloads/");
    _builder.newLine();
    _builder.append("eggs/");
    _builder.newLine();
    _builder.append(".eggs/");
    _builder.newLine();
    _builder.append("lib/");
    _builder.newLine();
    _builder.append("lib64/");
    _builder.newLine();
    _builder.append("parts/");
    _builder.newLine();
    _builder.append("sdist/");
    _builder.newLine();
    _builder.append("var/");
    _builder.newLine();
    _builder.append("wheels/");
    _builder.newLine();
    _builder.append("share/python-wheels/");
    _builder.newLine();
    _builder.append("*.egg-info/");
    _builder.newLine();
    _builder.append(".installed.cfg");
    _builder.newLine();
    _builder.append("*.egg");
    _builder.newLine();
    _builder.append("MANIFEST");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# PyInstaller");
    _builder.newLine();
    _builder.append("#  Usually these files are written by a python script from a template");
    _builder.newLine();
    _builder.append("#  before PyInstaller builds the exe, so as to inject date/other infos into it.");
    _builder.newLine();
    _builder.append("*.manifest");
    _builder.newLine();
    _builder.append("*.spec");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Installer logs");
    _builder.newLine();
    _builder.append("pip-log.txt");
    _builder.newLine();
    _builder.append("pip-delete-this-directory.txt");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Unit test / coverage reports");
    _builder.newLine();
    _builder.append("htmlcov/");
    _builder.newLine();
    _builder.append(".tox/");
    _builder.newLine();
    _builder.append(".nox/");
    _builder.newLine();
    _builder.append(".coverage");
    _builder.newLine();
    _builder.append(".coverage.*");
    _builder.newLine();
    _builder.append(".cache");
    _builder.newLine();
    _builder.append("nosetests.xml");
    _builder.newLine();
    _builder.append("coverage.xml");
    _builder.newLine();
    _builder.append("*.cover");
    _builder.newLine();
    _builder.append(".hypothesis/");
    _builder.newLine();
    _builder.append(".pytest_cache/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Translations");
    _builder.newLine();
    _builder.append("*.mo");
    _builder.newLine();
    _builder.append("*.pot");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Django stuff:");
    _builder.newLine();
    _builder.append("*.log");
    _builder.newLine();
    _builder.append("local_settings.py");
    _builder.newLine();
    _builder.append("db.sqlite3");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Flask stuff:");
    _builder.newLine();
    _builder.append("instance/");
    _builder.newLine();
    _builder.append(".webassets-cache");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Scrapy stuff:");
    _builder.newLine();
    _builder.append(".scrapy");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Sphinx documentation");
    _builder.newLine();
    _builder.append("docs/_build/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# PyBuilder");
    _builder.newLine();
    _builder.append("target/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Jupyter Notebook");
    _builder.newLine();
    _builder.append(".ipynb_checkpoints");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# IPython");
    _builder.newLine();
    _builder.append("profile_default/");
    _builder.newLine();
    _builder.append("ipython_config.py");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# pyenv");
    _builder.newLine();
    _builder.append(".python-version");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# celery beat schedule file");
    _builder.newLine();
    _builder.append("celerybeat-schedule");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# SageMath parsed files");
    _builder.newLine();
    _builder.append("*.sage.py");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Environments");
    _builder.newLine();
    _builder.append(".env");
    _builder.newLine();
    _builder.append(".venv");
    _builder.newLine();
    _builder.append("env/");
    _builder.newLine();
    _builder.append("venv/");
    _builder.newLine();
    _builder.append("ENV/");
    _builder.newLine();
    _builder.append("env.bak/");
    _builder.newLine();
    _builder.append("venv.bak/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Spyder project settings");
    _builder.newLine();
    _builder.append(".spyderproject");
    _builder.newLine();
    _builder.append(".spyproject");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Rope project settings");
    _builder.newLine();
    _builder.append(".ropeproject");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# mkdocs documentation");
    _builder.newLine();
    _builder.append("/site");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# mypy");
    _builder.newLine();
    _builder.append(".mypy_cache/");
    _builder.newLine();
    _builder.append(".dmypy.json");
    _builder.newLine();
    _builder.append("dmypy.json");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Pyre type checker");
    _builder.newLine();
    _builder.append(".pyre/");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    return _builder;
  }
}
